unit cVCMTThread;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, uVCMTDLL;

type

{ TVCMTDummyObject }

TVCMTDummyObject = class
private
public
      Tag : Integer;
end;

TVCMTOnExecute           = procedure(xdata : TVCMTDummyObject) of object;


{ TVCMTThread }

TVCMTThread = class(TComponent)
private
   FHandle    : MT_THREAD_HANDLE;
   FOnExecute : TVCMTOnExecute;

public
   FCallCount : Integer;

   constructor Create(AOwner: TComponent); reintroduce;
   destructor Destroy; override;

   procedure Start(ato : Cardinal);
   procedure CallExecute(xdata : TVCMTDummyObject);
published
   property OnExecute : TVCMTOnExecute read FOnexecute write FOnexecute;

end;


implementation

procedure OnExecuteClb(pCBData : Pointer); cdecl;
var
   a : TVCMTDummyObject;
   x : Integer;
begin
   a := TVCMTDummyObject.Create;

   // This executes the callback in the object for tests
   //TVCMTThread(pCBData).CallExecute(a);

   // a wait loop to keep the execution some time in this routine
   x := 0;
   while x < 100 do
   begin
     x := x + 1;
   end;

   // free and nil the object
   //FreeAndNil(a);

   // just free
   a.Free;
end;

{ TVCMTThread }

constructor TVCMTThread.Create(AOwner: TComponent);
begin
    inherited;

    FOnExecute := nil;
    FHandle    := uVCMTDLL.vcmtdll_NewThread();
    uVCMTDLL.vcmtdll_RegisterCallback(FHandle,@OnExecuteClb,self);
end;

destructor TVCMTThread.Destroy;
begin
    uVCMTDLL.vcmtdll_DeleteThread(FHandle);
    inherited;
end;

procedure TVCMTThread.Start(ato: Cardinal);
begin
   uVCMTDLL.vcmtdll_StartThread(FHandle,ato);
end;

procedure TVCMTThread.CallExecute(xdata : TVCMTDummyObject);
begin
  if Assigned(FOnExecute) then
    FOnExecute(xdata);
end;

end.

