unit uCBTest;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, uVCMTDLL, cVCMTThread, LMessages, Windows;

const
  CM_DOWRITE = WM_USER+100;

type

  { TMainForm }

  TMainForm = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
    FThreads : TList;
  protected
    procedure WndProc(var TheMessage : TLMessage); override;
  public
    { public declarations }
    procedure WriteMsg(amsg : string);
    procedure WriteMsgAsync(amsg : string);
    procedure OnExecuteProc(xdata : TVCMTDummyObject);
  end; 

var
  MainForm: TMainForm;

implementation


{ TMainForm }

procedure TMainForm.Button1Click(Sender: TObject);
var
   index : Integer;
   aitem : TVCMTThread;
begin
  WriteMsg('--> start test');
  // init threads if first execute
  if FThreads.Count = 0 then
  begin
       for index := 0 to 20 do
       begin
           aitem := TVCMTThread.Create(self);
           aitem.OnExecute := @OnExecuteProc;
           FThreads.Add(aitem);
       end;
  end;

  // start threads
  for index := 0 to FThreads.Count-1 do
  begin
     TVCMTThread(FThreads.Items[index]).Start(10);
  end;

end;

procedure TMainForm.FormCreate(Sender: TObject);
begin

  // load dll
  if not uVCMTDLL.LoadDll then
  begin
       ShowMessage('cannot load dll');
  end;

  FThreads := TList.Create;
  Memo1.Lines.Clear;
  WriteMsg('== Lazarus VC MT Callback Test ==');
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
   index : Integer;
begin
   for index := 0 to FThreads.Count - 1 do
   begin
     TVCMTThread(FThreads.Items[index]).Free;
   end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  self.Width:=600;
  self.Height:=300;
end;

procedure TMainForm.WndProc(var TheMessage: TLMessage);
begin
  if TheMessage.Msg = CM_DOWRITE then
  begin
       WriteMsg('xx');
  end;
  inherited WndProc(TheMessage);
end;

procedure TMainForm.WriteMsg(amsg: string);
begin
  Memo1.Lines.Add(amsg);
end;

procedure TMainForm.WriteMsgAsync(amsg: string);
begin
  PostMessage(Handle, CM_DOWRITE, 1, 0);
end;

procedure TMainForm.OnExecuteProc(xdata: TVCMTDummyObject);
begin
  // this codes crashes the app
  //WriteMsgAsync('xx');
end;

initialization
  {$I uCBTest.lrs}

end.

