#include "othread.h"
#include <windows.h>
#include <process.h>
#include <stdio.h>


void executionThread (LPVOID pParam)
{
  MTdata* data = (MTdata*)pParam;

  if (NULL != data && NULL != data->pCBFunc){
    ////////////////////////////////////////////////
    // Do I have to wait before I call the function:
    if (0!= data->iDelay){
      Sleep(data->iDelay);
    }
    ////////////////////////////////////////////////
    // callback function:
    ((void(MT_C_DECL *)(void*))data->pCBFunc)(data->pCBData);
  }
}


MTTHREAD::MTTHREAD(){
  m_MTdata.pCBFunc = NULL;
  m_MTdata.pCBData = NULL;
}


MTTHREAD::~MTTHREAD(){
}

void MTTHREAD::MTREGISTERCB(void* pCBFunc, void* pCBData){
  m_MTdata.pCBFunc = pCBFunc;
  m_MTdata.pCBData = pCBData;
}


void MTTHREAD::MTSTART(unsigned int iDelay){
  if (NULL != m_MTdata.pCBFunc){
    ////////////////////////////////////////////////
    // Set delay value:
    m_MTdata.iDelay = iDelay;
    ////////////////////////////////////////////////
    // Start thread:
    HANDLE hThread = (HANDLE)_beginthread(executionThread, 32776, &m_MTdata);
  }
  else{
    printf ("Please register Callback before start thread\n");
  }
}




